---------------------------------------------------------------
-- Company: NTNU
-- Engineer: Tom Erik Tysse
-- Design Name: Downscale_module
-- Additional Comments: Downscaler used for simulation
---------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library std;
use std.textio.all;

entity downscale_module is
--  Port ( );
end downscale_module;

architecture Behavioral of downscale_module is
constant WIDTH  : integer := 512;
constant HEIGHT : integer := 512;
subtype pixel     is integer range 0 to 255;
type mem_type     is array (integer range 0 to 3*WIDTH-1) of pixel; 
type out_mem_type is array (integer range 0 to WIDTH/2) of pixel;
signal row_0    : mem_type;
signal row_1    : mem_type;
signal R        : out_mem_type;
signal G        : out_mem_type;
signal B        : out_mem_type;
signal col      : integer := 0;
signal row      : integer := 0;
signal clock    : bit := '0';
signal endoffile: bit := '0';
signal row_order: integer := 0; 
signal cont_read: integer := 0;
signal suspend  : integer := 0;
begin

clock <= not (clock) after 1 ns;

read_proc : process
    file      in_file    : text is in 
              "C:\Users\Tom\Desktop\in_image.txt";
    variable  in_line    : line; 
    variable  data_read    : integer;
begin
wait until clock = '1' and clock'event;
if (not endfile(in_file)) then 
if (suspend < 2) then
        readline(in_file, in_line);  
        read(in_line, data_read);   
        if (row_order = 0) then
            row_0(col) <= data_read;
        elsif (row_order = 1) then
            row_1(col) <= data_read;
        end if; 
        col <= col + 1;
        if (col = 3*WIDTH-1) then
            col <= 0; 
            row <= row + 1;
            suspend <= suspend + 1;
            row_order <= row_order + 1;
            if (row_order = 2) then
                row_order <= 0;
            end if;
        end if;
end if;
else
    endoffile <= '1';
end if;
if (cont_read = 1) then
  suspend <= 0;
end if;
end process read_proc;

write_proc : process 
    file      out_file  : text is out 
              "C:\Users\Tom\Desktop\out_image.txt";
    variable  out_line  : line; 
begin
wait until clock = '0' and clock'event;
if(endoffile='0') then
    if (suspend = 2) then
  --      if (row mod 2 = 0) then
        for j in 0 to (3*WIDTH-1) loop     
            if (j mod 6 = 0) then
                  R(j/6) <= (row_0(j)+ row_1(j) 
                         + row_0(j+3) + row_1(j+3)) / 4;
                  G(j/6) <= (row_0(j+1)+ row_1(j+1) 
                         + row_0(j+4) + row_1(j+4)) / 4;
                  B(j/6) <= (row_0(j+2)+ row_1(j+2) 
                         + row_0(j+5) + row_1(j+5)) / 4;
            end if;
        end loop;               
        for j in 0 to ((WIDTH/2) - 1) loop
            write(out_line,R(j));
            writeline(out_file,out_line);
            write(out_line,G(j));
            writeline(out_file,out_line);
            write(out_line,B(j));
            writeline(out_file,out_line);
        end loop;
  --      end if;
        cont_read <= 1;
    else
        cont_read <= 0;
    end if;
else
null;
end if;          
end process write_proc;
end Behavioral;