----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 05/27/2017 09:00:42 PM
-- Design Name: 
-- Module Name: upscale_sub - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library std;
use std.textio.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity upscale_module is
--  Port ( );
end upscale_module;

architecture Behavioral of upscale_module is
constant WIDTH : integer := 512;
constant HEIGTH : integer := 512;
subtype pixel is integer range 0 to 255;
type mem_type is array (integer range 0 to 3*WIDTH-1) of pixel; -- 128 x 2 = 256 --- 128 x 3 = 
type out_mem_type is array (integer range 0 to 2*WIDTH-1) of pixel;
signal row_0  : mem_type;
signal row_1  : mem_type;
signal row_2  : mem_type;
signal R_0 : out_mem_type;
signal R_1 : out_mem_type;
signal G_0 : out_mem_type;
signal G_1 : out_mem_type;
signal B_0 : out_mem_type;
signal B_1 : out_mem_type;
signal col : integer := 0;
signal row : integer := 0;
signal clock,endoffile : bit := '0';
--signal extra : integer := 0;
signal  row_order : integer := 0; 
signal  cont_read : integer := 0;
signal state : integer := 0;
signal  suspend : integer := 0;

begin


clock <= not (clock) after 1 ns;    --clock with time period 2 ns


--read process
reading :
process
    file      infile    : text is in  "C:\Users\Tom\Desktop\in_image.txt";   --declare input file
    variable  inline    : line; --line number declaration
    variable  dataread    : integer;
begin
wait until clock = '1' and clock'event;
--if (endoffile = '1') then
--    extra <= 1
--end if;

if (not endfile(infile)) then   --checking the "END OF FILE" is not reached.  
if (suspend = 0) then
        readline(infile, inline);       --reading a line from the file.
        read(inline, dataread);   
        if (row_order = 0) then
            row_0(col) <= dataread;
        elsif (row_order = 1) then
            row_1(col) <= dataread;
        elsif(row_order = 2) then
            row_2 (col) <= dataread;
        end if; 
        col <= col + 1;
        if (col = 3*WIDTH-1) then
            col <= 0; 
            row <= row + 1;
            suspend <= 1;
            row_order <= row_order + 1;
            if (row_order = 3) then
                row_order <= 0;
            end if;
        end if;
end if;
else
    endoffile <='1';         --set signal to tell end of file read file is reached.
end if;
if (cont_read = 1) then
  suspend <= 0;
end if;
end process reading;

--write process
writing :
process
    file      outfile  : text is out "C:\Users\Tom\Desktop\out_image.txt";  --declare output file
    variable  outline  : line;   --line number declaration  
begin
wait until clock = '0' and clock'event;
if(endoffile='0') then   --if the file end is not reached.
--write(linenumber,value(real type),justified(side),field(width),digits(natural));
if (suspend = 1) then
        for j in 0 to (3*WIDTH-1) loop
            if (j mod 3 = 0) then              
                if (row < 2 or row > (HEIGTH-3)) then 
                        if (row_order = 0) then   
                            R_0((j/3)*2) <= row_0(j);
                            G_0((j/3)*2) <= row_0(j+1);
                            B_0((j/3)*2) <= row_0(j+2);              
                            R_1((j/3)*2) <= row_0(j);
                            G_1((j/3)*2) <= row_0(j+1);
                            B_1((j/3)*2) <= row_0(j+2);
                            R_0(((j/3)*2)+1) <= row_0(j);
                            G_0(((j/3)*2)+1) <= row_0(j+1);
                            B_0(((j/3)*2)+1) <= row_0(j+2);              
                            R_1(((j/3)*2)+1) <= row_0(j);
                            G_1(((j/3)*2)+1) <= row_0(j+1);
                            B_1(((j/3)*2)+1) <= row_0(j+2);
                        elsif(row_order = 1) then
                            R_0((j/3)*2) <= row_1(j);
                            G_0((j/3)*2) <= row_1(j+1);
                            B_0((j/3)*2) <= row_1(j+2);              
                            R_1((j/3)*2) <= row_1(j);
                            G_1((j/3)*2) <= row_1(j+1);
                            B_1((j/3)*2) <= row_1(j+2);
                            R_0(((j/3)*2)+1) <= row_1(j);
                            G_0(((j/3)*2)+1) <= row_1(j+1);
                            B_0(((j/3)*2)+1) <= row_1(j+2);              
                            R_1(((j/3)*2)+1) <= row_1(j);
                            G_1(((j/3)*2)+1) <= row_1(j+1);
                            B_1(((j/3)*2)+1) <= row_1(j+2);
                        elsif(row_order = 2) then
                            R_0((j/3)*2) <= row_2(j);
                            G_0((j/3)*2) <= row_2(j+1);
                            B_0((j/3)*2) <= row_2(j+2);              
                            R_1((j/3)*2) <= row_2(j);
                            G_1((j/3)*2) <= row_2(j+1);
                            B_1((j/3)*2) <= row_2(j+2);
                            R_0(((j/3)*2)+1) <= row_2(j);
                            G_0(((j/3)*2)+1) <= row_2(j+1);
                            B_0(((j/3)*2)+1) <= row_2(j+2);              
                            R_1(((j/3)*2)+1) <= row_2(j);
                            G_1(((j/3)*2)+1) <= row_2(j+1);
                            B_1(((j/3)*2)+1) <= row_2(j+2);
                        end if;
                elsif (j < 6 or j > (3*WIDTH-7)) then
                    if (row_order = 0) then  
                        R_0((j/3)*2) <= row_0(j);
                        G_0((j/3)*2) <= row_0(j+1);
                        B_0((j/3)*2) <= row_0(j+2);       
                        R_1((j/3)*2) <= row_0(j);
                        G_1((j/3)*2) <= row_0(j+1);
                        B_1((j/3)*2) <= row_0(j+2);   
                        R_0(((j/3)*2)+1) <= row_0(j);
                        G_0(((j/3)*2)+1) <= row_0(j+1);
                        B_0(((j/3)*2)+1) <= row_0(j+2);              
                        R_1(((j/3)*2)+1) <= row_0(j);
                        G_1(((j/3)*2)+1) <= row_0(j+1);
                        B_1(((j/3)*2)+1) <= row_0(j+2);    
                    elsif(row_order = 1) then
                        R_0((j/3)*2) <= row_1(j);
                        G_0((j/3)*2) <= row_1(j+1);
                        B_0((j/3)*2) <= row_1(j+2);       
                        R_1((j/3)*2) <= row_1(j);
                        G_1((j/3)*2) <= row_1(j+1);
                        B_1((j/3)*2) <= row_1(j+2);  
                        R_0(((j/3)*2)+1) <= row_1(j);
                        G_0(((j/3)*2)+1) <= row_1(j+1);
                        B_0(((j/3)*2)+1) <= row_1(j+2);              
                        R_1(((j/3)*2)+1) <= row_1(j);
                        G_1(((j/3)*2)+1) <= row_1(j+1);
                        B_1(((j/3)*2)+1) <= row_1(j+2);
                    elsif(row_order = 2) then
                        R_0((j/3)*2) <= row_2(j);
                        G_0((j/3)*2) <= row_2(j+1);
                        B_0((j/3)*2) <= row_2(j+2);       
                        R_1((j/3)*2) <= row_2(j);
                        G_1((j/3)*2) <= row_2(j+1);
                        B_1((j/3)*2) <= row_2(j+2);
                        R_0(((j/3)*2)+1) <= row_2(j);
                        G_0(((j/3)*2)+1) <= row_2(j+1);
                        B_0(((j/3)*2)+1) <= row_2(j+2);              
                        R_1(((j/3)*2)+1) <= row_2(j);
                        G_1(((j/3)*2)+1) <= row_2(j+1);
                        B_1(((j/3)*2)+1) <= row_2(j+2);
                    end if;
                else
                     if (row_order = 0) then      
                       -- Row 1
                       -- Row 2
                       -- Row 0
                        if (abs(row_2(j-3) - row_2(j+3)) < 10 and abs(row_0(j) - row_1(j)) < 10) then
                           if (abs(row_1(j) - row_2(j-3)) < 10) then
                               R_0((j/3)*2) <= row_2(j-3);
                               G_0((j/3)*2) <= row_2(j-2);
                               B_0((j/3)*2) <= row_2(j-1);
                           else
                               R_0((j/3)*2) <= row_2(j);
                               G_0((j/3)*2) <= row_2(j+1);
                               B_0((j/3)*2) <= row_2(j+2);
                           end if;
                           if (abs(row_1(j) - row_2(j+3)) < 10) then
                               R_0((j/3)*2+1) <= row_2(j+3);
                               G_0((j/3)*2+1) <= row_2(j+4);
                               B_0((j/3)*2+1) <= row_2(j+5);    
                           else
                               R_0((j/3)*2+1) <= row_2(j);
                               G_0((j/3)*2+1) <= row_2(j+1);
                               B_0((j/3)*2+1) <= row_2(j+2);
                           end if;
                           if (abs(row_2(j-3) - row_0(j)) < 10) then
                               R_1((j/3)*2) <= row_2(j-3);
                               G_1((j/3)*2) <= row_2(j-2);
                               B_1((j/3)*2) <= row_2(j-1);   
                           else
                               R_1((j/3)*2) <= row_2(j);
                               G_1((j/3)*2) <= row_2(j+1);
                               B_1((j/3)*2) <= row_2(j+2);                                   
                           end if;
                           if (abs (row_0(j) - row_2(j+3)) < 10) then
                               R_1((j/3)*2+1) <= row_2(j+3);
                               G_1((j/3)*2+1) <= row_2(j+4);
                               B_1((j/3)*2+1) <= row_2(j+5);     
                           else
                               R_1((j/3)*2+1) <= row_2(j);
                               G_1((j/3)*2+1) <= row_2(j+1);
                               B_1((j/3)*2+1) <= row_2(j+2);         
                           end if; 
                        else
                           R_0((j/3)*2) <= row_2(j);
                           G_0((j/3)*2) <= row_2(j+1);
                           B_0((j/3)*2) <= row_2(j+2);                            
                           R_0((j/3)*2+1) <= row_2(j);
                           G_0((j/3)*2+1) <= row_2(j+1);
                           B_0((j/3)*2+1) <= row_2(j+2);      
                           R_1((j/3)*2) <= row_2(j);
                           G_1((j/3)*2) <= row_2(j+1);
                           B_1((j/3)*2) <= row_2(j+2);      
                           R_1((j/3)*2+1) <= row_2(j);
                           G_1((j/3)*2+1) <= row_2(j+1);
                           B_1((j/3)*2+1) <= row_2(j+2);                                      
                        end if;   
                   elsif(row_order = 1) then
                       -- Row 2
                       -- Row 0
                       -- Row 1
                        if (abs(row_0(j-3) - row_0(j+3)) < 10 and abs(row_1(j) - row_2(j)) < 10) then
                           if (abs(row_2(j) - row_0(j-3)) < 10) then
                               R_0((j/3)*2) <= row_0(j-3);
                               G_0((j/3)*2) <= row_0(j-2);
                               B_0((j/3)*2) <= row_0(j-1);
                           else
                               R_0((j/3)*2) <= row_0(j);
                               G_0((j/3)*2) <= row_0(j+1);
                               B_0((j/3)*2) <= row_0(j+2);
                           end if;
                           if (abs(row_2(j) - row_0(j+3)) < 10) then
                               R_0((j/3)*2+1) <= row_0(j+3);
                               G_0((j/3)*2+1) <= row_0(j+4);
                               B_0((j/3)*2+1) <= row_0(j+5);    
                           else
                               R_0((j/3)*2+1) <= row_0(j);
                               G_0((j/3)*2+1) <= row_0(j+1);
                               B_0((j/3)*2+1) <= row_0(j+2);
                           end if;
                           if (abs(row_0(j-3) - row_1(j)) < 10) then
                               R_1((j/3)*2) <= row_0(j-3);
                               G_1((j/3)*2) <= row_0(j-2);
                               B_1((j/3)*2) <= row_0(j-1);   
                           else
                               R_1((j/3)*2) <= row_0(j);
                               G_1((j/3)*2) <= row_0(j+1);
                               B_1((j/3)*2) <= row_0(j+2);                                   
                           end if;
                           if (abs(row_1(j) - row_0(j+3)) < 10) then
                               R_1((j/3)*2+1) <= row_0(j+3);
                               G_1((j/3)*2+1) <= row_0(j+4);
                               B_1((j/3)*2+1) <= row_0(j+5);     
                           else
                               R_1((j/3)*2+1) <= row_0(j);
                               G_1((j/3)*2+1) <= row_0(j+1);
                               B_1((j/3)*2+1) <= row_0(j+2);         
                           end if; 
                        else
                           R_0((j/3)*2) <= row_0(j);
                           G_0((j/3)*2) <= row_0(j+1);
                           B_0((j/3)*2) <= row_0(j+2);                            
                           R_0((j/3)*2+1) <= row_0(j);
                           G_0((j/3)*2+1) <= row_0(j+1);
                           B_0((j/3)*2+1) <= row_0(j+2);      
                           R_1((j/3)*2) <= row_0(j);
                           G_1((j/3)*2) <= row_0(j+1);
                           B_1((j/3)*2) <= row_0(j+2);      
                           R_1((j/3)*2+1) <= row_0(j);
                           G_1((j/3)*2+1) <= row_0(j+1);
                           B_1((j/3)*2+1) <= row_0(j+2);                                      
                        end if;       
                   elsif(row_order = 2) then
                       -- Row 0
                       -- Row 1
                       -- Row 2
                        if (abs(row_1(j-3) - row_1(j+3)) < 10 and abs(row_0(j) - row_2(j)) < 10) then
                           if (abs(row_0(j) - row_1(j-3)) < 10) then
                               R_0((j/3)*2) <= row_1(j-3);
                               G_0((j/3)*2) <= row_1(j-2);
                               B_0((j/3)*2) <= row_1(j-1);
                           else
                               R_0((j/3)*2) <= row_1(j);
                               G_0((j/3)*2) <= row_1(j+1);
                               B_0((j/3)*2) <= row_1(j+2);
                           end if;
                           if (abs(row_0(j) - row_1(j+3)) < 10) then
                               R_0((j/3)*2+1) <= row_1(j+3);
                               G_0((j/3)*2+1) <= row_1(j+4);
                               B_0((j/3)*2+1) <= row_1(j+5);    
                           else
                               R_0((j/3)*2+1) <= row_1(j);
                               G_0((j/3)*2+1) <= row_1(j+1);
                               B_0((j/3)*2+1) <= row_1(j+2);
                           end if;
                           if (abs(row_1(j-3) - row_2(j)) < 10) then
                               R_1((j/3)*2) <= row_1(j-3);
                               G_1((j/3)*2) <= row_1(j-2);
                               B_1((j/3)*2) <= row_1(j-1);   
                           else
                               R_1((j/3)*2) <= row_1(j);
                               G_1((j/3)*2) <= row_1(j+1);
                               B_1((j/3)*2) <= row_1(j+2);                                   
                           end if;
                           if (abs(row_2(j) - row_1(j+3)) < 10) then
                               R_1((j/3)*2+1) <= row_1(j+3);
                               G_1((j/3)*2+1) <= row_1(j+4);
                               B_1((j/3)*2+1) <= row_1(j+5);     
                           else
                               R_1((j/3)*2+1) <= row_1(j);
                               G_1((j/3)*2+1) <= row_1(j+1);
                               B_1((j/3)*2+1) <= row_1(j+2);         
                           end if; 
                        else
                           R_0((j/3)*2) <= row_1(j);
                           G_0((j/3)*2) <= row_1(j+1);
                           B_0((j/3)*2) <= row_1(j+2);                            
                           R_0((j/3)*2+1) <= row_1(j);
                           G_0((j/3)*2+1) <= row_1(j+1);
                           B_0((j/3)*2+1) <= row_1(j+2);      
                           R_1((j/3)*2) <= row_1(j);
                           G_1((j/3)*2) <= row_1(j+1);
                           B_1((j/3)*2) <= row_1(j+2);      
                           R_1((j/3)*2+1) <= row_1(j);
                           G_1((j/3)*2+1) <= row_1(j+1);
                           B_1((j/3)*2+1) <= row_1(j+2);                                      
                        end if;           
                   end if;
               end if;
            end if;
        end loop;
        for i in 0 to 1 loop
            if (i = 0) then
                for j in 0 to (2*WIDTH-1) loop
                    write(outline, R_0(j));
                    writeline(outfile, outline); 
                    write(outline, G_0(j));
                    writeline(outfile, outline); 
                    write(outline, B_0(j));
                    writeline(outfile, outline); 
                end loop;
            else
                for j in 0 to (2*WIDTH-1) loop
                    write(outline, R_1(j));
                    writeline(outfile, outline); 
                    write(outline, G_1(j));
                    writeline(outfile, outline); 
                    write(outline, B_1(j));
                    writeline(outfile, outline); 
                end loop;
            end if;
        end loop;    
    cont_read <= 1;
 else 
    cont_read <= 0;
end if;
else
null;
end if;

end process writing;
end Behavioral;
